 /* Tabela CUSTOLOGIST: Custo de Logstica */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CUSTOLOGIST */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CUSTOLOGIST,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_GER_CUSTOLOGIST
AFTER DELETE OR INSERT OR UPDATE
ON CUSTOLOGIST FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(300);
  V_DTOPER    DATE;

  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_CDFILLOGOPER VARCHAR2(4);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' Fornecedor=' || :OLD.CDFORNECED;
      END IF;

      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' Produto=' || :OLD.CDPRODUTO;
      END IF;

      IF :OLD.DTINIVIGCLOG IS NOT NULL THEN
         V_DESC := V_DESC || ' Vigencia=' || :OLD.DTINIVIGCLOG;
      END IF;

      IF :OLD.VRPECUSTOLOG IS NOT NULL THEN
         V_DESC := V_DESC || ' PercentoLog=' || :OLD.VRPECUSTOLOG;
      END IF;

      IF :OLD.VRVRCUSTOLOG IS NOT NULL THEN
         V_DESC := V_DESC || ' ValorLog=' || :OLD.VRVRCUSTOLOG;
      END IF;

      IF :OLD.VRPESEGURLOG IS NOT NULL THEN
         V_DESC := V_DESC || ' PercentoSeg=' || :OLD.VRPESEGURLOG;
      END IF;

      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDFORNECED||:OLD.CDPRODUTO||:OLD.DTINIVIGCLOG;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.VRPECUSTOLOG,0) <> NVL(:NEW.VRPECUSTOLOG,0) ) OR
            (NVL(:OLD.VRVRCUSTOLOG,0) <> NVL(:NEW.VRVRCUSTOLOG,0) ) OR
            (NVL(:OLD.VRPESEGURLOG,0) <> NVL(:NEW.VRPESEGURLOG,0) ) THEN

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDFORNECED||:OLD.CDPRODUTO||:OLD.DTINIVIGCLOG;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL||:NEW.CDFORNECED||:NEW.CDPRODUTO||:NEW.DTINIVIGCLOG;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC := V_DESC || 'Filial='      || NVL(:OLD.CDFILIAL, :NEW.CDFILIAL);
      V_DESC := V_DESC || ' Fornecedor=' || NVL(:OLD.CDFORNECED, :NEW.CDFORNECED);
      V_DESC := V_DESC || ' Produto='    || NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO);
      V_DESC := V_DESC || ' Vigencia='   || NVL(:OLD.DTINIVIGCLOG, :NEW.DTINIVIGCLOG);


      IF (NVL(:OLD.VRPECUSTOLOG,0) <> NVL(:NEW.VRPECUSTOLOG,0) ) THEN
         V_DESC := V_DESC || ' PercentoLog=' || :NEW.VRPECUSTOLOG;
      END IF;

      IF (NVL(:OLD.VRVRCUSTOLOG,0) <> NVL(:NEW.VRVRCUSTOLOG,0) ) THEN
         V_DESC := V_DESC || ' ValorLog=' || :NEW.VRVRCUSTOLOG;
      END IF;

      IF (NVL(:OLD.VRPESEGURLOG,0) <> NVL(:NEW.VRPESEGURLOG,0) ) THEN
         V_DESC := V_DESC || ' PercentoSeg=' || :NEW.VRPESEGURLOG;
      END IF;
   END IF;

   IF (V_TIPO <> '0')  THEN
      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         WEBTUNNING(V_DSREMOTEADDR,
                    V_DSREMOTEHOST,
                    V_DSSERVERRDM,
                    V_DSSERVMETHOD,
                    V_DSREMOTEOPER);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('CUSTOLOGIST',  V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CUSTOLOGIST','4.11.017'); END;
/

